---
- name: Install and configure fail2ban
  block:
    - name: Gather package facts
      ansible.builtin.package_facts:
        manager: auto  # auto will automatically detect the package manager

    - name: Check if a package is installed
      ansible.builtin.fail:
        msg: "'{{ item }}' is not installed!"
      when: item not in ansible_facts.packages
      with_items:
        - fail2ban

    - name: Copy fail2ban configuration
      ansible.builtin.copy:
        src: jail.local
        dest: /etc/fail2ban/jail.local
        owner: root
        group: root
        mode: '0644'
  become: yes
